! Introduction to Fortran 95/2003 Exercise 2
program ex2_procedures
  implicit none
  integer, parameter :: max_iterations = 10, n = 100
  integer, dimension(n,n) :: array1, array2
  integer :: i, iter
  
  ! the following is a joint solution to all 2a-c
  
  call init_array(array1)
!  do i = 1, n
!     write (*,'(100I1)') array1(i,:)
!  end do
  
  do iter = 1, max_iterations, 2
     call update(array1, array2)
     call update(array2, array1)
  end do
  
  do i = 1, n
     write (*,'(100I1)') array1(i,:)
  end do
  
contains

  subroutine init_array(array)
    implicit none
    integer, dimension(n,n), intent(out) :: array
    real, dimension(n,n) :: rnd_array

! ex 2a
    array = 0
    array(50,:) = 1
    array(:,50) = 1

! ex 2c
!    call random_number(rnd_array)
!    array = nint(rnd_array)
  end subroutine init_array
    
  subroutine update(array_a, array_b)
    implicit none
    integer, dimension(n,n), intent(in)  :: array_a
    integer, dimension(n,n), intent(out) :: array_b
    integer :: i, j, nsum, iplus, iminus, jplus, jminus
    
    do j = 1, 100
       ! generate periodic boundaries
       jminus = j - 1
       jplus  = j + 1
       if (j == 1) jminus  = 100
       if (j == 100) jplus = 1
       do i = 1, 100
          iminus = i - 1
          iplus  = i + 1
          if (i == 1) iminus  = 100
          if (i == 100) iplus = 1
          ! determine the sum of neighboring elements
          nsum = array_a(iminus,jminus) + array_a(i,jminus) +  array_a(iplus,jminus) + &
               & array_a(iminus,  j   ) +                      array_a(iplus,  j   ) + &
               & array_a(iminus,jplus ) + array_a(i,jplus ) +  array_a(iplus,jplus )
          if (nsum == 2) then
             array_b(i,j) = array_a(i,j)
          else if (nsum == 3) then
             array_b(i,j) = 1
          else
             array_b(i,j) = 0
          end if
       end do
    end do
  end subroutine update
  
end program ex2_procedures
