! Introduction to Fortran 95/2003 Exercises 4, 6
module gol_io
  
  type GoL_board
     integer, dimension(:,:), pointer :: board
     integer :: iter
     integer :: width
     integer :: height
  end type GoL_board

contains

  subroutine read_data(iter, height, width)
    ! parser for user input (part 3e)
    implicit none
    integer, intent(out) :: iter, height, width

    write (*,*) 'Insert the number of iterations'
    read(*,*) iter
    write (*,*) 'Insert the size of the board (height width)'
    read(*,*) height, width
  end subroutine read_data

  subroutine read_data_dd(board, maxit)
    ! modified read-in routine for Exercise 5
    implicit none
    type(GoL_board), intent(out) :: board
    integer, intent(out) :: maxit
    integer :: h, w

    write (*,*) 'Insert the number of iterations'
    read(*,*) maxit
    write (*,*) 'Insert the size of the board (height width)'
    read(*,*) h, w
    board%height = h
    board%width = w
  end subroutine read_data_dd

  subroutine read_command_line(iter, height, width)
    ! The solution for Exercise 6
    implicit none
    integer, intent(out) :: iter, height, width
    character(len=10) :: args(3)
    integer :: n_args, i
    n_args = command_argument_count()
    if (n_args /= 3) then             
      write(*,*) ' Usage : ./gol #iterations height width'
      call abort()
    end if
    do i = 1, 3
      call get_command_argument(i, args(i))
      args(i) = trim(adjustl(args(i)))
    end do
    read(args(1),*) iter
    read(args(2),*) height
    read(args(3),*) width
  end subroutine read_command_line

  subroutine draw(board, height, width, iter)
    ! Drawing the board to a netpbm file; solution to Exercise 3d
    implicit none
    integer, parameter :: print_unit = 10
    integer, dimension(:,:), pointer :: board
    integer, intent(in) :: height, width, iter
    character(len=15) :: filename, cnt
    character(len=10) :: printw, printform
    integer :: i

    write(printform,'(A1,I0,A3)') '(', width, 'I2)' 
    write(filename,'(A5,I5.5,A4)')  'life_', iter, '.pbm'
    open(print_unit, file=filename, status='replace', &
        action='write')
    write(print_unit,'(A)') 'P1'
    write(print_unit,'(A,I5)') '# Iteration number ', iter
    write(print_unit,'(2I8)') width, height
    do i = 1, height
      write(print_unit,printform) board(i,1:width)
    end do
    close(print_unit, status='keep')
  end subroutine draw

  subroutine draw_dd(gboard)
    ! Modified draw routine for a version with derived datatype
    implicit none
    integer, parameter :: print_unit = 10
    type(GoL_board), intent(in) :: gboard
    character(len=14) :: filename
    character(len=10) :: printw, printform
    integer :: i

    write(printform,'(A1,I0,A3)') '(', gboard%width, 'I2)' 
    write(filename,'(A5,I5.5,A4)')  'life_', gboard%iter, '.pbm'
    open(print_unit, file=filename, status='replace', &
        action='write')
    write(print_unit,'(A)') 'P1'
    write(print_unit,'(A,I5)') '# Iteration number ', gboard%iter
    write(print_unit,'(2I8)') gboard%width, gboard%height
    do i = 1, gboard%height
      write(print_unit,printform) gboard%board(i,1:gboard%width)
    end do
    close(print_unit, status='keep')
  end subroutine draw_dd

end module gol_io
